<?
    require_once "Weathermap.class.php";

    $mapdir="configs";
    $gridsnap=10;

    function snap($coord)
    {
        global $gridsnap;
        
        if($gridsnap==0)
        {
            return($coord);
        }
        else
        {
            return($coord - ($coord % $gridsnap));
        }
    }

    function show_startpage()
    {
        global $mapdir;
     
        print "Welcome to Weathermap. Do you want to:<p>";   
        print "Create A New Map:<br>";
        print "<form method=GET>";
        print "Named: <input type=text name=mapname size=20>";
        
        print "<input name=state type=hidden value=newmap>";
        print "<input type=submit value=Create>";
        print "</form>";
        print "OR<br>";
        print "Open An Existing Map (looking in $mapdir):<ul>";

        if( is_dir($mapdir))
        {
            $n=0;
            $dh = opendir($mapdir);
            if($dh)
            {
                while($file = readdir($dh))
                {
                    if(is_file($mapdir.'/'.$file))
                    {
                        print "<li><a href=\"?state=main&mapname=$file\">$file</a></li>\n";
                        $n++;
                    }
                }
                closedir($dh);
            }
            else
            {
                print "<LI>Can't Open mapdir to read</LI>";
            }
            if($n==0)
            {
                print "<LI>No files</LI>";
            }
        }   
        else
        {     
            print "<LI>NO DIRECTORY named $mapdir</LI>";
        }
            
        print "</UL>";
    }
    
    function show_mainpage($map)
    {
        global $mapname;
        
        $map->DrawMap('null');
        
        print "<h3>Weathermap editor<h3>";
        print "<form method=GET>";
        print "<SELECT name=state>";
        print "<OPTION value=clicktest>Click Test (click where)</OPTION>";

        print "<OPTION value=addnode>Add A Node (click where)</OPTION>";
        print "<OPTION value=startlink>Add A New Link (click first node)</OPTION>";
        print "<OPTION value=setlegend>Set Legend Position (click where)</OPTION>";
        print "</SELECT><br>";
        print "<input name=mapname type=hidden value=$mapname>";
        print "<input style=\"border: dashed black 1px\" type=image name=clickmap SRC=\"wm.php?state=draw&mapname=$mapname\">";
        print "</form>";

        
        print "<pre>";
        print_r($map);
        print "</pre>";
    }
    
    $state = "";
    $mapname = "";
    if(isset($_REQUEST['state'])) { $state = $_REQUEST['state']; }
    if(isset($_REQUEST['mapname'])) { $mapname = $_REQUEST['mapname']; }
    $mapfile = $mapdir.'/'.$mapname;        
         
    $map = new WeatherMap;
           
    switch ($state)
    {
        case "setlegend":
            $x = intval($_REQUEST['clickmap_x']);
            $y = intval($_REQUEST['clickmap_y']);

            $map->ReadConfig($mapfile);

            $map->keyx = $x;
            $map->keyy = $y;

            $map->WriteConfig($mapfile);
            show_mainpage($map);
       
            break;
        case "endlink":
            $map->ReadConfig($mapfile);
            $map->DrawMap('null');

            $x = intval($_REQUEST['clickmap_x']);
            $y = intval($_REQUEST['clickmap_y']);
            $target = $map->imap->hitTest($x,$y,'NODE:');
            $first = $_REQUEST['first'];
            
            if(substr($target,0,4) == 'NODE')
            {
                    $firstnode = substr($first,5);
                    $secondnode = substr($target,5);
                    
                    if($firstnode != $secondnode)
                    {
                        print "Adding a link from $firstnode to $secondnode";
                        $newlink = new WeatherMapLink;
                        $newlink->a = $map->nodes[$firstnode];
                        $newlink->b = $map->nodes[$secondnode];
                        $newlink->name = "$firstnode-$secondnode";
                        $newlink->bandwidth_in=10000;
                        $newlink->bandwidth_out=10000;

                        $map->links[$newlink->name] = $newlink;
                    }
                    $map->WriteConfig($mapfile);
                    show_mainpage($map);

            }
            break;
    
        case "startlink":
            $map->ReadConfig($mapfile);
            $map->DrawMap('null');

            $x = intval($_REQUEST['clickmap_x']);
            $y = intval($_REQUEST['clickmap_y']);
            $target = $map->imap->hitTest($x,$y,'NODE:');
            
            if(substr($target,0,4) == 'NODE')
            {
                        
                print "<h3>Weathermap editor - Choose the next link<h3>";
                print "<form method=GET>";

                print "<input name=mapname type=hidden value=$mapname>";
                print "<input name=selected type=hidden value=$target>";
                print "<input name=first type=hidden value=$target>";
                print "<input name=state type=hidden value=endlink>";

                print "<input style=\"border: dashed black 1px\" type=image name=clickmap SRC=\"wm.php?state=draw&mapname=$mapname&selected=$target\">";
                print "</form>";
            }
            else
            {
                show_mainpage($map);
            }

            break;
        case "clicktest":
            $map->ReadConfig($mapfile);
            $map->DrawMap('null');
            
            $x = intval($_REQUEST['clickmap_x']);
            $y = intval($_REQUEST['clickmap_y']);
            $target = $map->imap->hitTest($x,$y);
            print "You clicked on: ";
            if($target) { print "$target"; } else { print "Nothing (we know about)"; }
            
            show_mainpage($map);

            break;
        case "addnode":
            $map->ReadConfig($mapfile);

            $node = new WeatherMapNode;
            $node->x = snap($_REQUEST['clickmap_x']);
            $node->y = snap($_REQUEST['clickmap_y']);
            $node->name = "node".time();
            $node->label = "NODE";
            
           // print_r ($_REQUEST);          
            
            $map->nodes[$node->name] = $node;
            $map->WriteConfig($mapfile);
            
            show_mainpage($map);

            break;

        case "draw":
            header('Content-type: image/png');
            $map->ReadConfig($mapfile);
            // $map->nodes['vlan2000']->selected=1;
            // $map->links['fw1ext-vlan188']->selected=1;

            if(isset($_REQUEST['selected']))
            {
                $selected = $_REQUEST['selected'];
                if(substr($selected,0,5) == 'NODE:')
                {
                    $nodename = substr($selected,5);
                    $map->nodes[$nodename]->selected=1;
                }
                
                if(substr($selected,0,5) == 'LINK:')
                {
                    $linkname = substr($selected,5);
                    $map->links[$linkname]->selected=1;
                }
            }

            $map->RandomData();
            $map->DrawMap();
            break;
            
        case "newmap":         
            
            if(file_exists($mapfile))
            {
                print "Map file already exists. Pick another name.";
            }
            else
            {
                $map->WriteConfig($mapfile);
            }
            print "<a href=\"?mapname=$mapname&state=main\">Continue</a>";
            break;
        case "main":
            $map->ReadConfig($mapfile);
       //     $map->nodes['vlan2000']->selected=1;
        //    $map->links['fw1ext-vlan188']->selected=1;

            show_mainpage($map);
            break;
        default:
            show_startpage();
            break;
    }
    
    
?>