#!/usr/local/bin/php
<?php
    # PHP Weathermap 0.4 - Pre-release software. For testing
    # Copyright Howard Jones, 2005 howie@thingy.com
    # http://wotsit.thingy.com/haj/cacti/
    # Released under the GNU Public License
    require_once 'Console/Getopt.php';
    require_once "Weathermap.class.php";
    if (!extension_loaded('gd')) {
        if (!dl('gd.so') && !dl('gd.dll')) {
            die("\n\nNo image (gd) extension was found, or could be loaded. This is required by weathermap.\n\n");
        }
    }
    $map = new Weathermap;
    $output = "html";
    $configfile = "weathermap.conf";
    $imagefile = "weathermap.png";
    $htmlfile = "";
    $DEBUG = 0;
    $dumpafter = 0;

        // *****************************************************************************
    // THIS IS THE ONE LINE IN HERE YOU MIGHT HAVE TO CHANGE!
    $map->rrdtool = "/usr/bin/rrdtool";
    // $map->rrdtool = "/usr/local/rrdtool-1.0.49/bin/rrdtool";
    // *****************************************************************************
    
    // initialize object
    $cg = new Console_Getopt();
    $short_opts = "";
    $long_opts = array("image-uri=", "config=", "output=", "version", "help", "debug", "htmloutput=", "dumpafter","bulge","sizedebug");
    $args = $cg->readPHPArgv();

    $ret = $cg->getopt($args, $short_opts, $long_opts);
    $gopts = $ret[0];
    if (sizeof($gopts) >0) {
        foreach($gopts as $o) {
            switch ($o[0]) {
                case '--config':
                    $configfile = $o[1];
                break;
                case '--htmloutput':
                    $htmlfile = $o[1];
                break;
                case '--dumpafter':
                    $dumpafter = 1;
                break;
                case '--image-uri':
                    $map->imageuri = $o[1];
                break;
                case '--debug':
                    $DEBUG = 1;
                    $map->debugging = TRUE;
                case '--sizedebug':
                    $map->sizedebug = TRUE;
                    break;
                case '--bulge':
                    $map->widthmod = TRUE;
                    break;
                break;
                case '--output':
                    $imagefile = $o[1];
                break;
            }
        }
    }
    $map->ReadConfig($configfile);
    // fill in some random data for now
    // $map->RandomData();
    $map->ReadData();
    if ($imagefile != "") {
        $map->DrawMap($imagefile);
        $map->imagefile = $imagefile;
    }
    if ($htmlfile != "") {
        $fd = fopen($htmlfile, "w");
        fwrite($fd, $map->MakeHTML());
        fclose($fd);
    }
    if ($dumpafter == 1) {
        print_r($map);
    }
?>
